#!/usr/bin/env python
# -*- Python -*-

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM_aist
import RTC

import codecs

# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
ModelLorder_spec = ["implementation_id", "ModelLorder", 
		 "type_name",         "ModelLorder", 
		 "description",       "Model Lorder Component", 
		 "version",           "0.1", 
		 "vendor",            "Kyusyu", 
		 "category",          "TEST", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

class ModelLorder(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_body = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._bodyOut = OpenRTM_aist.OutPort("body", self._d_body, OpenRTM_aist.RingBuffer(8))
		

		# Set InPort buffers
		
		# Set OutPort buffers
		self.registerOutPort("body",self._bodyOut)
		
		self.redata = LoadModel("test.txt")
		

		

		

		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		

		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	def onInitialize(self):
		# Bind variables and configuration variable
		
		return RTC.RTC_OK


	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onActivated(self, ec_id):
            self._d_body.data = self.redata
            self._bodyOut.write()
	
	    return RTC.RTC_OK
	
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onExecute(self, ec_id):
            
            
	    #return RTC.RTC_OK
	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	
def LoadModel(file):
    fp = codecs.open(file, "r", "utf-8")
    redata = []
    for line in fp:
            line.rstrip()
            data = line.split(",")
            if data[0] == "Joint":
                if data[1] == "Hinge":
                    redata.append(1)
                    redata.append(0)
                    for i in range(0, 9):
                        redata.append(float(data[2+i]))
                if data[1] == "Slinder":
                    redata.append(1)
                    redata.append(1)
                    for i in range(0, 5):
                        redata.append(float(data[2+i]))
                if data[1] == "Fix":
                    redata.append(1)
                    redata.append(2)
                    for i in range(0, 2):
                        redata.append(float(data[2+i]))
            if data[0] == "Body":
                if data[1] == "Box":
                    redata.append(0)
                    redata.append(0)
                    for i in range(0, 7):
                        redata.append(float(data[2+i]))
                if data[1] == "Capsule":
                    redata.append(0)
                    redata.append(3)
                    for i in range(0, 7):
                        redata.append(float(data[2+i]))
                if data[1] == "Sphere":
                    redata.append(0)
                    redata.append(1)
                    for i in range(0, 5):
                        redata.append(float(data[2+i]))
                if data[1] == "Cylinder":
                    redata.append(0)
                    redata.append(2)
                    for i in range(0, 7):
                        redata.append(float(data[2+i]))
            if data[0] == "Force":
                redata.append(2)
                for i in range(0, 2):
                    redata.append(float(data[1+i]))
            if data[0] == "Touch":
                redata.append(3)
                for i in range(0, 2):
                    redata.append(float(data[1+i]))
            if data[0] == "Gyro":
                redata.append(4)
                for i in range(0, 2):
                    redata.append(float(data[1+i]))            
    fp.close()
    return redata


def MyModuleInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=ModelLorder_spec)
    manager.registerFactory(profile,
                            ModelLorder,
                            OpenRTM_aist.Delete)

    # Create a component
    comp = manager.createComponent("ModelLorder")



def main():
	mgr = OpenRTM_aist.Manager.init(len(sys.argv), sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

